/* 与えられた日付に曜日と祝日名を追加して返すショートコード */
function ryus_day_dayedit($atts){
	// day は　yyyy-mm-dd の形で指定されている
	/* 引数を展開する */
	extract(
		shortcode_atts(
			array(
				'day' => ''
			),
			$atts
		)
	);
	if($day == ''){
		$day = date("Y-m-d", strtotime('today'));
	}
	return _ryus_day_dayedit($day);
}

function _ryus_day_dayedit($day){
	// dayで渡された日付に曜日と祝日であればその内容を追加して返す
	$youbi = _waYoubi(date('w', strtotime($day)));
	$shukujitsu = _getShukujitsu($day);
	// html。必要に応じて適宜変更する
	$dayHtml = '<div style="width:100%;border:dotted 1px #333;padding:5px;margin-bottom:5px;">'.$day.'('.$youbi.') '.$shukujitsu.'</div>';

	return $dayHtml;
}
add_shortcode( 'ryus_day_dayedit', 'ryus_day_dayedit' );

function _waYoubi($w){
	$waYoubi = array('日', '月', '火', '水', '木', '金', '土');
	return $waYoubi[$w];
}

function _getShukujitsu($day){
	// 日本の祝日feed
	$feed = 'https://www.google.com/calendar/feeds/ja.japanese%23holiday%40group.v.calendar.google.com/public/basic';
	$start = urlencode(date(DATE_ATOM, strtotime($day.' 00:00:00 +9 hour')));
	$end = urlencode(date(DATE_ATOM, strtotime($day.' 23:59:59  +9 hour')));
	$addParam = '?start-min='.$start.'&start-max='.$end;
	$xml = simplexml_load_file($feed.$addParam);
	if(isset($xml->entry)){
			return $xml->entry[0]->title;
	}
	return '';
}

/* Googleカレンダーから指定された日の予定を表示する */
function ryus_google_calendar_day($atts) {
	/* 引数を展開する */
	extract(
		shortcode_atts(
			array(
				'feed' => '',
				'day' => '',
				'plus' => ''
			),
			$atts
		)
	);

	$feedString = '';
	if($day == ''){
		$day = date("Y-m-d", strtotime('today'));
	}
	if($plus != ''){
		$day = date("Y-m-d", strtotime($day.' +'.$plus.' day'));
	}
	$start = urlencode(date(DATE_ATOM, strtotime($day.' 00:00:00 +9 hour')));
	$end = urlencode(date(DATE_ATOM, strtotime($day.' 23:59:59  +9 hour')));

	$feedString = _ryus_day_dayedit($day);
	// singleevents=true にしないと繰り返し予定が他の予定と同じ形で取得できない
	$addParam = '?start-min='.$start.'&start-max='.$end.'&singleevents=true&orderby=starttime';

	$xml = simplexml_load_file($feed.$addParam);

	$entries = array(); // key=no
	$count = 0;
	$sortArray = array();
	
	foreach($xml->entry as $key=>$entry){
		$contents = explode("<br />", $entry->content[0]);
		$content = array();
		foreach ($contents as $val){
			if($val != ''){
				if (mb_substr($val, 0, 2) == '期間'){
					// 期間は　:　が複数あるので別処理
					$val = str_replace('期間:', '期間@', $val);
					$valExplode = explode('@', $val);
					// 期間の内容から日付とJSTを削除する
					$kikanTemp = explode(')', $valExplode[1]);
					$valExplode[1] = str_replace('JST', '', $kikanTemp[1]);
				} else {
					$valExplode = explode(':', $val);
				}
				if(count($valExplode) == 2){
					$valKey = $valExplode[0];
					if(strlen($valKey) > 0){
						$content[$valKey] = $valExplode[1];
					}
				}
			}
		}
		$title = (array)$entry->title;
		$content['title'] = $title[0];
		$entries[$count] = $content;
		if(isset($content['期間'])){
			$sortArray[$count] = $content['期間'];
		} else {
			// 終日予定を上に
			$sortArray[$count] = '';
		}
		$count++;
	}
	asort($sortArray);
	$feedString .= _entryEdit($entries, $sortArray);
	return $feedString;

}

function _entryEdit($entries, $sortArray){
	// Googleカレンダーより取得したentryを編集する
	// htmlを変更したいときはここを適宜変更
	$entryEdit = '';
	if(count($entries) < 1){
		return '本日の予定はありません。';
	}
	foreach($sortArray as $key=>$val){
		$entry = $entries[$key];
		// タイトル
		$entryEdit .= '<div style="font-weight:bold;">'.$entry['title'].'</div>';
		$entryEdit .= '<ul style="padding:5px;margin:10px;border-bottom:dotted 1px #333;">';
		// 期間 or 開始日　終日の時は開始日
		if(isset($entry['期間'])){
			$entryEdit .= '<li>時間：'.$entry['期間'].'</li>';
		} else {
			$entryEdit .= '<li>時間：終日'.'</li>';
		}
		// 場所
		if(isset($entry['場所'])){
			$entryEdit .= '<li>場所：'.$entry['場所'].'</li>';
		}
		// 場所
		if(isset($entry['予定の説明'])){
			$entryEdit .= '<li>説明：<div style="margin-left:10px;">'.nl2br($entry['予定の説明']).'</div></li>';
		}
		$entryEdit .= '</ul>';
	}	
	return $entryEdit;
}
add_shortcode( 'ryus_google_calendar_day', 'ryus_google_calendar_day' );
